diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/model/uan-phy-gen.cc ns-3.40/src/uan/model/uan-phy-gen.cc
--- ns-3.39/src/uan/model/uan-phy-gen.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/model/uan-phy-gen.cc	2023-09-27 13:30:37.890839800 -0700
@@ -20,11 +20,12 @@
 
 #include "uan-phy-gen.h"
 
+#include "acoustic-modem-energy-model.h"
 #include "uan-channel.h"
 #include "uan-net-device.h"
 #include "uan-transducer.h"
+#include "uan-tx-mode.h"
 
-#include "ns3/acoustic-modem-energy-model.h"
 #include "ns3/double.h"
 #include "ns3/energy-source-container.h"
 #include "ns3/log.h"
@@ -34,7 +35,6 @@
 #include "ns3/string.h"
 #include "ns3/trace-source-accessor.h"
 #include "ns3/traced-callback.h"
-#include "ns3/uan-tx-mode.h"
 #include "ns3/uinteger.h"
 
 namespace ns3
@@ -83,7 +83,7 @@
     }
 
     double intKp = -DbToKp(rxPowerDb); // This packet is in the arrivalList
-    UanTransducer::ArrivalList::const_iterator it = arrivalList.begin();
+    auto it = arrivalList.begin();
     for (; it != arrivalList.end(); it++)
     {
         intKp += DbToKp(it->GetRxPowerDb());
@@ -143,7 +143,7 @@
     // Get maximum arrival offset
     double maxAmp = -1;
     Time maxTapDelay(0);
-    UanPdp::Iterator pit = pdp.GetBegin();
+    auto pit = pdp.GetBegin();
     for (; pit != pdp.GetEnd(); pit++)
     {
         if (std::abs(pit->GetAmp()) > maxAmp)
@@ -161,7 +161,7 @@
     //  eq. 14
     double isiUpa =
         DbToKp(rxPowerDb) * pdp.SumTapsFromMaxNc(ts + clearingTime, ts); // added DpToKp()
-    UanTransducer::ArrivalList::const_iterator it = arrivalList.begin();
+    auto it = arrivalList.begin();
     double intKp = -DbToKp(effRxPowerDb);
     for (; it != arrivalList.end(); it++)
     {
@@ -312,7 +312,7 @@
         // generic EbNo
         EbNo *= mode.GetDataRateBps() / mode.GetBandwidthHz();
 
-        double M = (double)mode.GetConstellationSize();
+        auto M = (double)mode.GetConstellationSize();
 
         // standard squared quantized QAM, even number of bits per symbol supported
         int log2sqrtM = (int)::std::log2(sqrt(M));
@@ -1086,7 +1086,7 @@
 {
     const UanTransducer::ArrivalList& arrivalList = m_transducer->GetArrivalList();
 
-    UanTransducer::ArrivalList::const_iterator it = arrivalList.begin();
+    auto it = arrivalList.begin();
 
     double interfPower = 0;
 
@@ -1116,7 +1116,7 @@
 void
 UanPhyGen::NotifyListenersRxStart()
 {
-    ListenerList::const_iterator it = m_listeners.begin();
+    auto it = m_listeners.begin();
     for (; it != m_listeners.end(); it++)
     {
         (*it)->NotifyRxStart();
@@ -1126,7 +1126,7 @@
 void
 UanPhyGen::NotifyListenersRxGood()
 {
-    ListenerList::const_iterator it = m_listeners.begin();
+    auto it = m_listeners.begin();
     for (; it != m_listeners.end(); it++)
     {
         (*it)->NotifyRxEndOk();
@@ -1136,7 +1136,7 @@
 void
 UanPhyGen::NotifyListenersRxBad()
 {
-    ListenerList::const_iterator it = m_listeners.begin();
+    auto it = m_listeners.begin();
     for (; it != m_listeners.end(); it++)
     {
         (*it)->NotifyRxEndError();
@@ -1146,7 +1146,7 @@
 void
 UanPhyGen::NotifyListenersCcaStart()
 {
-    ListenerList::const_iterator it = m_listeners.begin();
+    auto it = m_listeners.begin();
     for (; it != m_listeners.end(); it++)
     {
         (*it)->NotifyCcaStart();
@@ -1156,7 +1156,7 @@
 void
 UanPhyGen::NotifyListenersCcaEnd()
 {
-    ListenerList::const_iterator it = m_listeners.begin();
+    auto it = m_listeners.begin();
     for (; it != m_listeners.end(); it++)
     {
         (*it)->NotifyCcaEnd();
@@ -1166,7 +1166,7 @@
 void
 UanPhyGen::NotifyListenersTxStart(Time duration)
 {
-    ListenerList::const_iterator it = m_listeners.begin();
+    auto it = m_listeners.begin();
     for (; it != m_listeners.end(); it++)
     {
         (*it)->NotifyTxStart(duration);
@@ -1176,7 +1176,7 @@
 void
 UanPhyGen::NotifyListenersTxEnd()
 {
-    ListenerList::const_iterator it = m_listeners.begin();
+    auto it = m_listeners.begin();
     for (; it != m_listeners.end(); it++)
     {
         (*it)->NotifyTxEnd();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/model/uan-phy.h ns-3.40/src/uan/model/uan-phy.h
--- ns-3.39/src/uan/model/uan-phy.h	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/model/uan-phy.h	2023-09-27 13:30:37.890839800 -0700
@@ -21,12 +21,13 @@
 #ifndef UAN_PHY_H
 #define UAN_PHY_H
 
+#include "uan-mac.h"
+#include "uan-prop-model.h"
+#include "uan-transducer.h"
+#include "uan-tx-mode.h"
+
 #include "ns3/device-energy-model.h"
 #include "ns3/object.h"
-#include "ns3/uan-mac.h"
-#include "ns3/uan-prop-model.h"
-#include "ns3/uan-transducer.h"
-#include "ns3/uan-tx-mode.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/model/uan-prop-model.cc ns-3.40/src/uan/model/uan-prop-model.cc
--- ns-3.39/src/uan/model/uan-prop-model.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/model/uan-prop-model.cc	2023-09-27 13:30:37.890839800 -0700
@@ -33,7 +33,7 @@
     os << pdp.GetNTaps() << '|';
     os << pdp.GetResolution().GetSeconds() << '|';
 
-    UanPdp::Iterator it = pdp.m_taps.begin();
+    auto it = pdp.m_taps.begin();
     for (; it != pdp.m_taps.end(); it++)
     {
         os << (*it).GetAmp() << '|';
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/model/uan-transducer.h ns-3.40/src/uan/model/uan-transducer.h
--- ns-3.39/src/uan/model/uan-transducer.h	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/model/uan-transducer.h	2023-09-27 13:30:37.890839800 -0700
@@ -20,11 +20,11 @@
 #ifndef UAN_TRANSDUCER_H
 #define UAN_TRANSDUCER_H
 
+#include "uan-prop-model.h"
 #include "uan-tx-mode.h"
 
 #include "ns3/object.h"
 #include "ns3/packet.h"
-#include "ns3/uan-prop-model.h"
 
 #include <list>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/model/uan-transducer-hd.cc ns-3.40/src/uan/model/uan-transducer-hd.cc
--- ns-3.39/src/uan/model/uan-transducer-hd.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/model/uan-transducer-hd.cc	2023-09-27 13:30:37.890839800 -0700
@@ -21,12 +21,12 @@
 
 #include "uan-channel.h"
 #include "uan-phy.h"
+#include "uan-prop-model.h"
 
 #include "ns3/double.h"
 #include "ns3/log.h"
 #include "ns3/pointer.h"
 #include "ns3/simulator.h"
-#include "ns3/uan-prop-model.h"
 
 namespace ns3
 {
@@ -62,7 +62,7 @@
         m_channel = nullptr;
     }
 
-    UanPhyList::iterator it = m_phyList.begin();
+    auto it = m_phyList.begin();
     for (; it != m_phyList.end(); it++)
     {
         if (*it)
@@ -71,7 +71,7 @@
             *it = nullptr;
         }
     }
-    ArrivalList::iterator ait = m_arrivalList.begin();
+    auto ait = m_arrivalList.begin();
     for (; ait != m_arrivalList.end(); ait++)
     {
         ait->GetPacket() = nullptr;
@@ -164,7 +164,7 @@
     if (m_state == RX)
     {
         NS_LOG_DEBUG("Transducer state = RX");
-        UanPhyList::const_iterator it = m_phyList.begin();
+        auto it = m_phyList.begin();
         for (; it != m_phyList.end(); it++)
         {
             NS_LOG_DEBUG("Calling StartRx");
@@ -191,7 +191,7 @@
     NS_LOG_DEBUG("Transducer transmitting:  TX delay = "
                  << delay << " seconds for packet size " << packet->GetSize()
                  << " bytes and rate = " << txMode.GetDataRateBps() << " bps");
-    UanPhyList::const_iterator it = m_phyList.begin();
+    auto it = m_phyList.begin();
     for (; it != m_phyList.end(); it++)
     {
         if (src != (*it))
@@ -245,7 +245,7 @@
 UanTransducerHd::RemoveArrival(UanPacketArrival arrival)
 {
     // Remove entry from arrival list
-    ArrivalList::iterator it = m_arrivalList.begin();
+    auto it = m_arrivalList.begin();
     for (; it != m_arrivalList.end(); it++)
     {
         if (it->GetPacket() == arrival.GetPacket())
@@ -254,7 +254,7 @@
             break;
         }
     }
-    UanPhyList::const_iterator ait = m_phyList.begin();
+    auto ait = m_phyList.begin();
     for (; ait != m_phyList.end(); ait++)
     {
         (*ait)->NotifyIntChange();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/model/uan-tx-mode.cc ns-3.40/src/uan/model/uan-tx-mode.cc
--- ns-3.39/src/uan/model/uan-tx-mode.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/model/uan-tx-mode.cc	2023-09-27 13:30:37.890839800 -0700
@@ -116,7 +116,7 @@
 bool
 UanTxModeFactory::NameUsed(std::string name)
 {
-    std::map<uint32_t, UanTxModeItem>::iterator it = m_modes.begin();
+    auto it = m_modes.begin();
 
     for (; it != m_modes.end(); it++)
     {
@@ -176,7 +176,7 @@
 UanTxModeFactory::UanTxModeItem&
 UanTxModeFactory::GetModeItem(std::string name)
 {
-    std::map<uint32_t, UanTxModeItem>::iterator it = m_modes.begin();
+    auto it = m_modes.begin();
     for (; it != m_modes.end(); it++)
     {
         if ((*it).second.m_name == name)
@@ -237,7 +237,7 @@
 {
     NS_ASSERT(modeNum < m_modes.size());
 
-    std::vector<UanTxMode>::iterator it = m_modes.begin();
+    auto it = m_modes.begin();
     for (uint32_t i = 0; i < modeNum; i++)
     {
         it++;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/visualizer/model/pyviz.cc ns-3.40/src/visualizer/model/pyviz.cc
--- ns-3.39/src/visualizer/model/pyviz.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/visualizer/model/pyviz.cc	2023-09-27 13:30:37.894839800 -0700
@@ -51,7 +51,7 @@
         }
         str = str.substr(cutAt + 1);
     }
-    if (str.length() > 0)
+    if (!str.empty())
     {
         results.push_back(str);
     }
@@ -298,8 +298,7 @@
     Time expirationTime = Simulator::Now() - Seconds(10);
 
     // Clear very old transmission records
-    for (std::map<TxRecordKey, TxRecordValue>::iterator iter = m_txRecords.begin();
-         iter != m_txRecords.end();)
+    for (auto iter = m_txRecords.begin(); iter != m_txRecords.end();)
     {
         if (iter->second.time < expirationTime)
         {
@@ -312,8 +311,7 @@
     }
 
     // Clear very old packets of interest
-    for (std::map<uint32_t, Time>::iterator iter = m_packetsOfInterest.begin();
-         iter != m_packetsOfInterest.end();)
+    for (auto iter = m_packetsOfInterest.begin(); iter != m_packetsOfInterest.end();)
     {
         if (iter->second < expirationTime)
         {
@@ -385,8 +383,7 @@
 PyViz::NetDeviceStatistics&
 PyViz::FindNetDeviceStatistics(int node, int interface)
 {
-    std::map<uint32_t, std::vector<NetDeviceStatistics>>::iterator nodeStatsIter =
-        m_nodesStatistics.find(node);
+    auto nodeStatsIter = m_nodesStatistics.find(node);
     std::vector<NetDeviceStatistics>* stats;
     if (nodeStatsIter == m_nodesStatistics.end())
     {
@@ -404,8 +401,7 @@
 bool
 PyViz::GetPacketCaptureOptions(uint32_t nodeId, const PacketCaptureOptions** outOptions) const
 {
-    std::map<uint32_t, PacketCaptureOptions>::const_iterator iter =
-        m_packetCaptureOptions.find(nodeId);
+    auto iter = m_packetCaptureOptions.find(nodeId);
     if (iter == m_packetCaptureOptions.end())
     {
         return false;
@@ -444,7 +440,7 @@
         while (metadataIterator.HasNext())
         {
             PacketMetadata::Item item = metadataIterator.Next();
-            std::set<TypeId>::iterator missingIter = missingHeaders.find(item.tid);
+            auto missingIter = missingHeaders.find(item.tid);
             if (missingIter != missingHeaders.end())
             {
                 missingHeaders.erase(missingIter);
@@ -495,7 +491,7 @@
         }
     }
 
-    std::map<Ptr<Node>, uint32_t>::iterator iter = m_packetDrops.find(node);
+    auto iter = m_packetDrops.find(node);
     if (iter == m_packetDrops.end())
     {
         m_packetDrops[node] = packet->GetSize();
@@ -698,8 +694,7 @@
 
     Ptr<Channel> channel = device->GetChannel();
 
-    std::map<TxRecordKey, TxRecordValue>::iterator recordIter =
-        m_txRecords.find(TxRecordKey(channel, uid));
+    auto recordIter = m_txRecords.find(TxRecordKey(channel, uid));
 
     if (recordIter == m_txRecords.end())
     {
@@ -722,10 +717,7 @@
     NS_LOG_DEBUG("m_transmissionSamples begin:");
     if (g_log.IsEnabled(ns3::LOG_DEBUG))
     {
-        for (std::map<TransmissionSampleKey, TransmissionSampleValue>::const_iterator iter =
-                 m_transmissionSamples.begin();
-             iter != m_transmissionSamples.end();
-             iter++)
+        for (auto iter = m_transmissionSamples.begin(); iter != m_transmissionSamples.end(); iter++)
         {
             NS_LOG_DEBUG(iter->first.transmitter
                          << "/" << iter->first.transmitter->GetId() << ", " << iter->first.receiver
@@ -736,8 +728,7 @@
     NS_LOG_DEBUG("m_transmissionSamples end.");
 #endif
 
-    std::map<TransmissionSampleKey, TransmissionSampleValue>::iterator iter =
-        m_transmissionSamples.find(key);
+    auto iter = m_transmissionSamples.find(key);
 
     if (iter == m_transmissionSamples.end())
     {
@@ -867,10 +858,7 @@
 {
     NS_LOG_DEBUG("GetTransmissionSamples BEGIN");
     TransmissionSampleList list;
-    for (std::map<TransmissionSampleKey, TransmissionSampleValue>::const_iterator iter =
-             m_transmissionSamples.begin();
-         iter != m_transmissionSamples.end();
-         iter++)
+    for (auto iter = m_transmissionSamples.begin(); iter != m_transmissionSamples.end(); iter++)
     {
         TransmissionSample sample;
         sample.transmitter = iter->first.transmitter;
@@ -890,9 +878,7 @@
 {
     NS_LOG_DEBUG("GetPacketDropSamples BEGIN");
     PacketDropSampleList list;
-    for (std::map<Ptr<Node>, uint32_t>::const_iterator iter = m_packetDrops.begin();
-         iter != m_packetDrops.end();
-         iter++)
+    for (auto iter = m_packetDrops.begin(); iter != m_packetDrops.end(); iter++)
     {
         PacketDropSample sample;
         sample.transmitter = iter->first;
@@ -915,10 +901,7 @@
 PyViz::GetNodesStatistics() const
 {
     std::vector<PyViz::NodeStatistics> retval;
-    for (std::map<uint32_t, std::vector<NetDeviceStatistics>>::const_iterator iter =
-             m_nodesStatistics.begin();
-         iter != m_nodesStatistics.end();
-         iter++)
+    for (auto iter = m_nodesStatistics.begin(); iter != m_nodesStatistics.end(); iter++)
     {
         NodeStatistics stats = {iter->first, iter->second};
         retval.push_back(stats);
@@ -931,7 +914,7 @@
 {
     NS_LOG_DEBUG("GetLastPackets: " << nodeId);
 
-    std::map<uint32_t, LastPacketsSample>::const_iterator iter = m_lastPackets.find(nodeId);
+    auto iter = m_lastPackets.find(nodeId);
     if (iter != m_lastPackets.end())
     {
         return iter->second;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/visualizer/visualizer/core.py ns-3.40/src/visualizer/visualizer/core.py
--- ns-3.39/src/visualizer/visualizer/core.py	2023-07-05 14:23:48.101428300 -0700
+++ ns-3.40/src/visualizer/visualizer/core.py	2023-09-27 13:30:37.894839800 -0700
@@ -69,7 +69,7 @@
     _import_error = None
 
 try:
-    import ipython_viewxxxxxxxxxx
+    from . import ipython_view
 except ImportError:
     ipython_view = None
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/visualizer/visualizer/ipython_view.py ns-3.40/src/visualizer/visualizer/ipython_view.py
--- ns-3.39/src/visualizer/visualizer/ipython_view.py	2023-07-05 14:23:48.101428300 -0700
+++ ns-3.40/src/visualizer/visualizer/ipython_view.py	2023-09-27 13:30:37.894839800 -0700
@@ -13,15 +13,21 @@
 # this file is a modified version of source code from the Accerciser project
 # https://wiki.gnome.org/Apps/Accerciser
 
-import gtk, gobject
+import gi
+gi.require_version('Gtk', '3.0')
+from gi.repository import Gtk
+from gi.repository import Gdk
+from gi.repository import GLib
+from gi.repository import Pango
+
+from pkg_resources import parse_version
+
 import re
 import sys
 import os
-from gi.repository import Pango
-from StringIO import StringIO
-import IPython
 
-from pkg_resources import parse_version
+from io import StringIO
+from functools import reduce
 
 ## Try to import IPython
 try:
@@ -41,6 +47,12 @@
   #  history level
   ## @var complete_sep
   #  separators
+  ## @var no_input_splitter
+  # no input splitter
+  ## @var lines
+  # lines
+  ## @var indent_spaces
+  # indent spaces
   ## @var prompt
   #  prompt
   ## @var header
@@ -52,8 +64,8 @@
   ## @var raw_input
   #  raw input
   ## Constructor
-  def __init__(self,argv=None,user_ns=None,user_global_ns=None,
-               cin=None, cout=None,cerr=None, input_func=None):
+  def __init__(self, argv=[], user_ns=None, user_global_ns=None,
+               cin=None, cout=None, cerr=None, input_func=None):
     """! Initializer
 
     @param self: this object
@@ -67,45 +79,47 @@
     """
     io = IPython.utils.io
     if input_func:
-      if parse_version(IPython.release.version) >= parse_version("1.2.1"):
-        IPython.terminal.interactiveshell.raw_input_original = input_func
-      else:
-        IPython.frontend.terminal.interactiveshell.raw_input_original = input_func
-    if cin:
-      io.stdin = io.IOStream(cin)
-    if cout:
-      io.stdout = io.IOStream(cout)
-    if cerr:
-      io.stderr = io.IOStream(cerr)
+      IPython.terminal.interactiveshell.raw_input_original = input_func
+    if IPython.version_info < (8,):
+      if cin:
+        io.stdin = io.IOStream(cin)
+      if cout:
+        io.stdout = io.IOStream(cout)
+      if cerr:
+        io.stderr = io.IOStream(cerr)
+    else:
+      if cin:
+        sys.stdin = cin
+      if cout:
+        sys.stdout = cout
+      if cerr:
+        sys.stderr = cerr
 
     # This is to get rid of the blockage that occurs during
     # IPython.Shell.InteractiveShell.user_setup()
-
     io.raw_input = lambda x: None
 
     os.environ['TERM'] = 'dumb'
     excepthook = sys.excepthook
 
-    from IPython.config.loader import Config
+    from traitlets.config.loader import Config
     cfg = Config()
     cfg.InteractiveShell.colors = "Linux"
+    cfg.Completer.use_jedi = False
 
-    # InteractiveShell's __init__ overwrites io.stdout,io.stderr with
-    # sys.stdout, sys.stderr, this makes sure they are right
-    #
-    old_stdout, old_stderr = sys.stdout, sys.stderr
-    sys.stdout, sys.stderr = io.stdout.stream, io.stderr.stream
+    if IPython.version_info < (8,):
+      # InteractiveShell's __init__ overwrites io.stdout,io.stderr with
+      # sys.stdout, sys.stderr, this makes sure they are right
+      old_stdout, old_stderr = sys.stdout, sys.stderr
+      sys.stdout, sys.stderr = io.stdout.stream, io.stderr.stream
 
     # InteractiveShell inherits from SingletonConfigurable, so use instance()
     #
-    if parse_version(IPython.release.version) >= parse_version("1.2.1"):
-      self.IP = IPython.terminal.embed.InteractiveShellEmbed.instance(\
-              config=cfg, user_ns=user_ns)
-    else:
-      self.IP = IPython.frontend.terminal.embed.InteractiveShellEmbed.instance(\
+    self.IP = IPython.terminal.embed.InteractiveShellEmbed.instance(\
               config=cfg, user_ns=user_ns)
 
-    sys.stdout, sys.stderr = old_stdout, old_stderr
+    if IPython.version_info < (8,):
+      sys.stdout, sys.stderr = old_stdout, old_stderr
 
     self.IP.system = lambda cmd: self.shell(self.IP.var_expand(cmd),
                                             header='IPython system call: ')
@@ -120,11 +134,17 @@
     self.complete_sep =  re.compile('[\s\{\}\[\]\(\)]')
     self.updateNamespace({'exit':lambda:None})
     self.updateNamespace({'quit':lambda:None})
-    self.IP.readline_startup_hook(self.IP.pre_readline)
     # Workaround for updating namespace with sys.modules
     #
     self.__update_namespace()
 
+    # Avoid using input splitter when not really needed.
+    # Perhaps it could work even before 5.8.0
+    # But it definitely does not work any more with >= 7.0.0
+    self.no_input_splitter = parse_version(IPython.release.version) >= parse_version('5.8.0')
+    self.lines = []
+    self.indent_spaces = ''
+
   def __update_namespace(self):
     """!
     Update self.IP namespace for autocompletion with sys.modules
@@ -140,11 +160,17 @@
     @return none
     """
     self.history_level = 0
-    orig_stdout = sys.stdout
-    sys.stdout = IPython.utils.io.stdout
 
-    orig_stdin = sys.stdin
-    sys.stdin = IPython.utils.io.stdin;
+    if IPython.version_info < (8,):
+      # this is needed because some functions in IPython use 'print' to print
+      # output (like 'who')
+
+      orig_stdout = sys.stdout
+      sys.stdout = IPython.utils.io.stdout
+
+      orig_stdin = sys.stdin
+      sys.stdin = IPython.utils.io.stdin
+
     self.prompt = self.generatePrompt(self.iter_more)
 
     self.IP.hooks.pre_prompt_hook()
@@ -160,21 +186,26 @@
       line = self.IP.raw_input(self.prompt)
     except KeyboardInterrupt:
       self.IP.write('\nKeyboardInterrupt\n')
-      self.IP.input_splitter.reset()
+      if self.no_input_splitter:
+        self.lines = []
+      else:
+        self.IP.input_splitter.reset()
     except:
       self.IP.showtraceback()
     else:
-      self.IP.input_splitter.push(line)
-      self.iter_more = self.IP.input_splitter.push_accepts_more()
-      self.prompt = self.generatePrompt(self.iter_more)
-      if (self.IP.SyntaxTB.last_syntax_error and
-          self.IP.autoedit_syntax):
-          self.IP.edit_syntax_error()
+      if self.no_input_splitter:
+        self.lines.append(line)
+        (status, self.indent_spaces) = self.IP.check_complete('\n'.join(self.lines))
+        self.iter_more = status == 'incomplete'
+      else:
+        self.IP.input_splitter.push(line)
+        self.iter_more = self.IP.input_splitter.push_accepts_more()
       if not self.iter_more:
-          if parse_version(IPython.release.version) >= parse_version("2.0.0-dev"):
-            source_raw = self.IP.input_splitter.raw_reset()
+          if self.no_input_splitter:
+            source_raw = '\n'.join(self.lines)
+            self.lines = []
           else:
-            source_raw = self.IP.input_splitter.source_raw_reset()[1]
+            source_raw = self.IP.input_splitter.raw_reset()
           self.IP.run_cell(source_raw, store_history=True)
           self.IP.rl_do_indent = False
       else:
@@ -182,9 +213,11 @@
           #
           self.IP.rl_do_indent = True
           pass
+      self.prompt = self.generatePrompt(self.iter_more)
 
-    sys.stdout = orig_stdout
-    sys.stdin = orig_stdin
+    if IPython.version_info < (8,):
+      sys.stdout = orig_stdout
+      sys.stdin = orig_stdin
 
   def generatePrompt(self, is_continuation):
     """!
@@ -195,17 +228,10 @@
 
     """
 
-    # Backwards compatibility with ipyton-0.11
-    #
-    ver = IPython.__version__
-    if '0.11' in ver:
-        prompt = self.IP.hooks.generate_prompt(is_continuation)
+    if is_continuation:
+      prompt = '... '
     else:
-        if is_continuation:
-            prompt = self.IP.prompt_manager.render('in2')
-        else:
-            prompt = self.IP.prompt_manager.render('in')
-
+      prompt = '>>> '
     return prompt
 
 
@@ -281,7 +307,7 @@
             return str1[:i]
         return str1
       if possibilities[1]:
-        common_prefix = reduce(_commonPrefix, possibilities[1]) or line[-1]
+        common_prefix = reduce(_commonPrefix, possibilities[1]) or split_line[-1]
         completed = line[:-len(split_line[-1])]+common_prefix
       else:
         completed = line
@@ -324,7 +350,8 @@
   """
   Specialized text view for console-like workflow.
 
-  @cvar ANSI_COLORS: Mapping of terminal colors to X11 names.
+  @cvar ANSI_COLORS: Mapping of terminal control sequence values to
+                     tuples containing foreground and background color names.
   @type ANSI_COLORS: dictionary
 
   @ivar text_buffer: Widget's text buffer.
@@ -336,20 +363,35 @@
   @ivar line_start: Start of command line mark.
   @type line_start: Gtk.TextMark
   """
-  ANSI_COLORS =  {'0;30': 'Black',     '0;31': 'Red',
-                  '0;32': 'Green',     '0;33': 'Brown',
-                  '0;34': 'Blue',      '0;35': 'Purple',
-                  '0;36': 'Cyan',      '0;37': 'LightGray',
-                  '1;30': 'DarkGray',  '1;31': 'DarkRed',
-                  '1;32': 'SeaGreen',  '1;33': 'Yellow',
-                  '1;34': 'LightBlue', '1;35': 'MediumPurple',
-                  '1;36': 'LightCyan', '1;37': 'White'}
+  ANSI_COLORS = {'0;30': ('Black', None),
+                 '0;31': ('Red', None),
+                 '0;32': ('Green', None),
+                 '0;33': ('Brown', None),
+                 '0;34': ('Blue', None),
+                 '0;35': ('Purple', None),
+                 '0;36': ('Cyan', None),
+                 '0;37': ('LightGray', None),
+                 '1;30': ('DarkGray', None),
+                 '1;31': ('DarkRed', None),
+                 '1;32': ('SeaGreen', None),
+                 '1;33': ('Yellow', None),
+                 '1;34': ('LightBlue', None),
+                 '1;35': ('MediumPurple', None),
+                 '1;36': ('LightCyan', None),
+                 '1;37': ('White', None),
+                 '38;5;124;43': ('DarkRed', 'Yellow'),
+                 '38;5;241': ('Gray', None),
+                 '38;5;241;43': ('Gray', 'Yellow'),
+                 '39': ('Black', None),
+                 '39;49': ('Red', 'White'),
+                 '43': (None, 'Yellow'),
+                 '49': (None, 'White')}
 
   def __init__(self):
     """
     Initialize console view.
     """
-    GObject.GObject.__init__(self)
+    Gtk.TextView.__init__(self)
     self.modify_font(Pango.FontDescription('Mono'))
     self.set_cursor_visible(True)
     self.text_buffer = self.get_buffer()
@@ -358,7 +400,8 @@
                                              False)
     for code in self.ANSI_COLORS:
       self.text_buffer.create_tag(code,
-                                  foreground=self.ANSI_COLORS[code],
+                                  foreground=self.ANSI_COLORS[code][0],
+                                  background=self.ANSI_COLORS[code][1],
                                   weight=700)
     self.text_buffer.create_tag('0')
     self.text_buffer.create_tag('notouch', editable=False)
@@ -376,7 +419,7 @@
     @param editable: If true, added text is editable.
     @return none
     """
-    GObject.idle_add(self._write, text, editable)
+    GLib.idle_add(self._write, text, editable)
 
   def _write(self, text, editable=False):
     """!
@@ -414,7 +457,7 @@
     @param prompt: Prompt to print.
     @return none
     """
-    GObject.idle_add(self._showPrompt, prompt)
+    GLib.idle_add(self._showPrompt, prompt)
 
   def _showPrompt(self, prompt):
     """!
@@ -434,7 +477,7 @@
     @param text: Text to use as replacement.
     @return none
     """
-    GObject.idle_add(self._changeLine, text)
+    GLib.idle_add(self._changeLine, text)
 
   def _changeLine(self, text):
     """!
@@ -466,7 +509,7 @@
     @param text: Text to show.
     @return none
     """
-    GObject.idle_add(self._showReturned, text)
+    GLib.idle_add(self._showReturned, text)
 
   def _showReturned(self, text):
     """!
@@ -485,11 +528,14 @@
     if text:
       self._write('\n')
     self._showPrompt(self.prompt)
-    self.text_buffer.move_mark(self.line_start,self.text_buffer.get_end_iter())
+    self.text_buffer.move_mark(self.line_start, self.text_buffer.get_end_iter())
     self.text_buffer.place_cursor(self.text_buffer.get_end_iter())
 
     if self.IP.rl_do_indent:
-      indentation = self.IP.input_splitter.indent_spaces * ' '
+      if self.no_input_splitter:
+        indentation = self.indent_spaces
+      else:
+        indentation = self.IP.input_splitter.indent_spaces * ' '
       self.text_buffer.insert_at_cursor(indentation)
 
   def onKeyPress(self, widget, event):
@@ -508,9 +554,9 @@
     selection_iter = self.text_buffer.get_iter_at_mark(selection_mark)
     start_iter = self.text_buffer.get_iter_at_mark(self.line_start)
     if event.keyval == Gdk.KEY_Home:
-      if event.get_state() & Gdk.ModifierType.CONTROL_MASK or event.get_state() & Gdk.ModifierType.MOD1_MASK:
+      if event.state & Gdk.ModifierType.CONTROL_MASK or event.state & Gdk.ModifierType.MOD1_MASK:
         pass
-      elif event.get_state() & Gdk.ModifierType.SHIFT_MASK:
+      elif event.state & Gdk.ModifierType.SHIFT_MASK:
         self.text_buffer.move_mark(insert_mark, start_iter)
         return True
       else:
@@ -520,6 +566,24 @@
       insert_iter.backward_cursor_position()
       if not insert_iter.editable(True):
         return True
+    elif event.state & Gdk.ModifierType.CONTROL_MASK and event.keyval in [ord('L'), ord('l')]:
+        # clear previous output on Ctrl+L, but remember current input line + cursor position
+        cursor_offset = self.text_buffer.get_property('cursor-position')
+        cursor_pos_in_line = cursor_offset - start_iter.get_offset() + len(self.prompt)
+        current_input = self.text_buffer.get_text(start_iter, self.text_buffer.get_end_iter(), False)
+        self.text_buffer.set_text(self.prompt + current_input)
+        self.text_buffer.move_mark(self.line_start, self.text_buffer.get_iter_at_offset(len(self.prompt)))
+        self.text_buffer.place_cursor(self.text_buffer.get_iter_at_offset(cursor_pos_in_line))
+        return True
+    elif event.state & Gdk.ModifierType.CONTROL_MASK and event.keyval in [Gdk.KEY_k, Gdk.KEY_K]:
+      # clear text after input cursor on Ctrl+K
+      if insert_iter.editable(True):
+        self.text_buffer.delete(insert_iter, self.text_buffer.get_end_iter())
+      return True
+    elif event.state & Gdk.ModifierType.CONTROL_MASK and event.keyval == Gdk.KEY_C:
+      # copy selection on Ctrl+C (upper-case 'C' only)
+      self.text_buffer.copy_clipboard(Gtk.Clipboard.get(Gdk.SELECTION_CLIPBOARD))
+      return True
     elif not event.string:
       pass
     elif start_iter.compare(insert_iter) <= 0 and \
@@ -569,7 +633,7 @@
     """
     ConsoleView.__init__(self)
     self.cout = StringIO()
-    IterableIPShell.__init__(self, cout=self.cout,cerr=self.cout,
+    IterableIPShell.__init__(self, cout=self.cout, cerr=self.cout,
                              input_func=self.raw_input)
     self.interrupt = False
     self.execute()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/CMakeLists.txt ns-3.40/src/wifi/CMakeLists.txt
--- ns-3.39/src/wifi/CMakeLists.txt	2023-07-05 14:23:48.101428300 -0700
+++ ns-3.40/src/wifi/CMakeLists.txt	2023-09-27 13:30:37.894839800 -0700
@@ -354,4 +354,5 @@
     test/wifi-txop-test.cc
     test/wifi-phy-cca-test.cc
     test/wifi-non-ht-dup-test.cc
+    test/wifi-phy-mu-mimo-test.cc
 )
